#ifndef _LISTA_H_
#define _LISTA_H_

#include "Elemento.h"

template<class TIPO>
class Lista
{
private:
	Elemento<TIPO>*  pPrimeiro;
	Elemento<TIPO>*  pAtual;

public:
	Lista();
	~Lista();
	bool incluir( TIPO pInfo );
	Elemento<TIPO>* getPrimeiro();
	Elemento<TIPO>* getUltimo();
};

template<class TIPO>
Lista<TIPO>::Lista()
{
	pPrimeiro = NULL;
	pAtual    = NULL;
}

template<class TIPO>
Lista<TIPO>::~Lista()
{
	Elemento<TIPO>* aux = pPrimeiro;
	while (aux != NULL)
	{
		pPrimeiro = aux->getProximo();
		delete aux;
		aux = pPrimeiro;
	}
}

template<class TIPO>
bool Lista<TIPO>::incluir( TIPO pInfo )
{
	if (NULL != pInfo)
	{
		Elemento<TIPO>* pElemento = new Elemento<TIPO>();
		pElemento->setInfo( pInfo );
		pElemento->setProximo( NULL );
		pElemento->setAnterior( NULL );
		if (NULL == pPrimeiro)
		{
			pAtual = pPrimeiro = pElemento;		
		}
		else
		{
			pAtual->setProximo( pElemento );
			pElemento->setAnterior( pAtual );
			pAtual = pElemento;
		}
		
		return true;
	}
	else
	{
		printf ( "Erro, elemento (informao) nulo(a) na lista. \n" );
		return false;
	}
}

template<class TIPO>
Elemento<TIPO>* Lista<TIPO>::getPrimeiro()
{
	return pPrimeiro;
}

template<class TIPO>
Elemento<TIPO>* Lista<TIPO>::getUltimo()
{
	return pAtual;
}

#endif
